<?php
namespace PAR\Controller;

use PAR\Controller\PARCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use PAR\Service\FindService;
use PAR\Traits\TResponse;

class FindController extends PARCrud {
    use TResponse;
    protected $findService;
   
    public function __construct($crudService, $environment, FindService $findService) {
        parent::__construct($crudService, $environment);
        $this->findService = $findService;
    }

    public function findIndiceFinanceiro(Request $request, Response $response) {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->findService->findIndiceFinanceiro($filtro);
            $this->sendResponse($data, 200);
          } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
         }
    }

    private function getFiltro($request) {
        if (isset($request->getParameters()["find"])) {
            $filtro = $request->getParameters()["find"];
        } else {
            $filtro = '';
        }
        return $filtro;
    } 
}
?>
