IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'GERANF_MAPARESUMO' AND
	        TYPE = 'P' 			          AND
	        U.UID = O.UID             	 AND
	        U.NAME = USER)
DROP PROCEDURE GERANF_MAPARESUMO
GO

CREATE PROCEDURE GERANF_MAPARESUMO
                 @P_CDEMPRESA    VARCHAR(2),
                 @P_CDINSCESTA   VARCHAR(16),
                 @P_DTINICIAL    DATETIME,
                 @P_DTFINAL      DATETIME,
                 @P_CDCTRLNUMENF VARCHAR(10),
                 @P_CDOPERACAO   VARCHAR(02)
AS
   DECLARE @V_NRLANCTONF   VARCHAR(20);
   DECLARE @V_NRNOTAFISC   VARCHAR(20);
   DECLARE @V_SEQUIMPOSTNF VARCHAR(02);
   DECLARE @V_INCIDENCIA   VARCHAR(01);
   DECLARE @V_TAMNF        NUMERIC(11);
   DECLARE @V_BASECALC     FLOAT;
   DECLARE @V_CDCLIENTE    VARCHAR(21);
   DECLARE @V_CDMODDOCFISC VARCHAR(2);
   DECLARE @V_IDTPIJURNF   VARCHAR(01);
   DECLARE @V_NRINSJURNF   VARCHAR(20);
   DECLARE @V_NRNOTAANTE   VARCHAR(20);
   DECLARE @V_CONTADOR     VARCHAR(20);
   DECLARE @V_FILIPROC     VARCHAR(04);
   DECLARE @V_NRSEQUITVEND VARCHAR(02);
   DECLARE @V_SITUTRIBPR   VARCHAR(03);
   DECLARE @V_CDGRUPOFISC  VARCHAR(03);
   DECLARE @V_PAISORIG     VARCHAR(04);
   DECLARE @V_ESTAORIG     VARCHAR(02);
   DECLARE @V_PAISDEST     VARCHAR(04);
   DECLARE @V_ESTADEST     VARCHAR(02);
   DECLARE @V_FISOPEITEM   VARCHAR(11);
   DECLARE @V_ALIQTEMP     VARCHAR(14);
   DECLARE @V_INCITEMP     VARCHAR(14);
   DECLARE @V_CSTTEMP      VARCHAR(14);
   DECLARE @V_CFOPTEMP     VARCHAR(14);
   DECLARE @V_IDENDEMIS    VARCHAR(01);
   DECLARE @V_MUNIORIG     VARCHAR(04);
   DECLARE @V_NRALIQTEMP   FLOAT;
   DECLARE @V_PARDEDTMP    FLOAT;
   DECLARE @V_PREDBCTMP    FLOAT;
   DECLARE @V_ALIQUTMP     FLOAT;
   DECLARE @V_IMPOSTOIT    FLOAT;
   DECLARE @V_TRATIMPST    VARCHAR(01);
   DECLARE @V_TAXABASECALC FLOAT;
   DECLARE @V_TAXAALIQUOTA FLOAT;
   DECLARE @V_PERDBCALC    FLOAT;
   DECLARE @V_BASECALCIT   FLOAT;
   DECLARE @V_IDTRIMPSTII  VARCHAR(01);
   DECLARE @V_LIQUIITEM    FLOAT;
   DECLARE @V_CONTABCALC   FLOAT;
   DECLARE @V_DSOBSFISCIT  VARCHAR(50);
   DECLARE @V_LANCTEMP     VARCHAR(20);
   DECLARE @V_NRLANCTEMP   VARCHAR(10);
   DECLARE @V_CDIMPOSTO    VARCHAR(02);
   DECLARE @V_NRCUPOM      VARCHAR(10);
   DECLARE @V_IDINTEREST   VARCHAR(01);
   DECLARE @V_IDINTERNA    VARCHAR(01);

   /* VARIVEIS DO CURSOR C_CORPONF */

   DECLARE @C_CORPONF_CDEMPRESA      VARCHAR(2);
   DECLARE @C_CORPONF_CDINSCESTA     VARCHAR(16);
   DECLARE @C_CORPONF_CDINSCMUNI     VARCHAR(16);
   DECLARE @C_CORPONF_CDFILIAL       VARCHAR(4);
   DECLARE @C_CORPONF_DTENTRVENDA    DATETIME;
   DECLARE @C_CORPONF_NRTAMNUMNFUT   NUMERIC(11);
   DECLARE @C_CORPONF_VRVENDA        FLOAT;
   DECLARE @C_CORPONF_NRCUPOMFIM     VARCHAR(10);
   DECLARE @C_CORPONF_NRCUPOMINI     VARCHAR(10);

   /* VARIVEIS DO CURSOR C_ITEMFISC */

   DECLARE @C_ITEMFISC_CDEMPRESA      VARCHAR(2);
   DECLARE @C_ITEMFISC_DTENTRVENDA    DATETIME;
   DECLARE @C_ITEMFISC_CDFILIAL       VARCHAR(4);
   DECLARE @C_ITEMFISC_IDTPIMPOSFIS   VARCHAR(1);
   DECLARE @C_ITEMFISC_VRPEALPRODIT   FLOAT;
   DECLARE @C_ITEMFISC_VRUNIT         FLOAT;
   DECLARE @C_ITEMFISC_BASECALC       FLOAT;
   DECLARE @C_ITEMFISC_VRIMPOSTO      FLOAT;
   DECLARE @C_ITEMFISC_CDCSTPROD      VARCHAR(03);
   DECLARE @C_ITEMFISC_CFOPITEM       VARCHAR(11);

   /* VARIVEIS DO CURSOR C_LANC */
   DECLARE @C_LANC_CDFILIALNF         VARCHAR(4);
   DECLARE @C_LANC_NRLANCTONF         VARCHAR(10);
   DECLARE @C_LANC_NRCUPOMFIM         VARCHAR(10);
   DECLARE @C_LANC_NRCUPOMINI         VARCHAR(10);

   /* VARIAVEIS DO CURSOR C_OUTROSIMP*/

   DECLARE @C_OUTROSIMP_CDARVPROD     VARCHAR(20);
   DECLARE @C_OUTROSIMP_VRLIQUIITEM   FLOAT;


   /* VARIAVEIS DO CURSOR C_INCIDENCIA*/

   DECLARE @C_INCIDENCIA_CDIMPOTEMP    VARCHAR(02);
   DECLARE @C_INCIDENCIA_CDFISCTEMP    VARCHAR(01);
   DECLARE @C_INCIDENCIA_IDTRATIMPTMP  VARCHAR(01);
   DECLARE @C_INCIDENCIA_IDCONSISTENT  VARCHAR(01);
   DECLARE @C_INCIDENCIA_IDIMPORECUP   VARCHAR(01);

   /* VARIAVEIS DO CURSOR C_IMPOSTONF*/

   DECLARE @C_IMPOSTONF_CDEMPRESA      VARCHAR(02);
   DECLARE @C_IMPOSTONF_CDINSCESTA     VARCHAR(16);
   DECLARE @C_IMPOSTONF_CDINSCMUNI     VARCHAR(16);
   DECLARE @C_IMPOSTONF_CDFILIEMIT     VARCHAR(04);
   DECLARE @C_IMPOSTONF_DTEMISSAO      DATETIME;
   DECLARE @C_IMPOSTONF_CDIMPOSTOIT    VARCHAR(02);
   DECLARE @C_IMPOSTONF_VRALIQIMPOIT   FLOAT;
   DECLARE @C_IMPOSTONF_VRREDBCIMPOIT  FLOAT;
   DECLARE @C_IMPOSTONF_VRPDEDIMPOIT   FLOAT;
   DECLARE @C_IMPOSTONF_CDFISCIMPOIT   VARCHAR(01);
   DECLARE @C_IMPOSTONF_CDSTRIBIMPOIT  VARCHAR(03);
   DECLARE @C_IMPOSTONF_CDFOPERIMPOIT  VARCHAR(11);
   DECLARE @C_IMPOSTONF_CDSCFOPIMPOIT  VARCHAR(03);
   DECLARE @C_IMPOSTONF_NRSEQITPRO     VARCHAR(01);
   DECLARE @C_IMPOSTONF_VRCONTIMPOIT   FLOAT;
   DECLARE @C_IMPOSTONF_VRBCALCIMPOIT  FLOAT;
   DECLARE @C_IMPOSTONF_VRIMPOSIT      FLOAT;
   DECLARE @C_IMPOSTONF_NRITPROIMPOS   VARCHAR(01);
   /*VARIAVEIS DO CURSOR C_NOTAFISCAL*/

   DECLARE @C_NOTAFISCAL_CDEMPRESA     VARCHAR(02);
   DECLARE @C_NOTAFISCAL_CDINSCESTA    VARCHAR(16);
   DECLARE @C_NOTAFISCAL_CDINSCMUNI    VARCHAR(16);
   DECLARE @C_NOTAFISCAL_CDFILIEMIT    VARCHAR(04);
   DECLARE @C_NOTAFISCAL_DTEMISSAO     DATETIME;
   DECLARE @C_NOTAFISCAL_NRTAMNUMNFUT  NUMERIC(11);
   DECLARE @C_NOTAFISCAL_VRNOTAFISC    FLOAT;

   DECLARE @C_UPDATENOTA_CDFILIAL      VARCHAR(04);
   DECLARE @C_UPDATENOTA_NRLANCTONF    VARCHAR(10);

   DECLARE @C_ATUALIZA_CDFILIAL        VARCHAR(04);
   DECLARE @C_ATUALIZA_NRLANCTONF      VARCHAR(10);

BEGIN

   DECLARE C_CORPONF CURSOR FOR (SELECT VD.CDEMPRESA, FI.CDINSCESTA, FI.CDINSCMUNI, FI.CDFILIAL, VD.DTENTRVENDA, P.NRTAMNUMNFUT,
                                        MAX(VD.NRCUPOMFIS) NRCUPOMFIM, MIN(VD.NRCUPOMFIS) NRCUPOMINI,
                                        SUM(ROUND((IT.QTPRODVEND * (IT.VRUNITVEND+IT.VRUNITVENDCL)),2,1)- ISNULL(IT.VRDESITVEND,0) + ISNULL(IT.VRACRITVEND,0)) AS VRVENDA
                                 FROM VENDA VD, FILIAL FI, PARAMFILIAL P,
                                      (SELECT DISTINCT CDFILIAL, CDCAIXA, NRSEQVENDA
                                       FROM MOVCAIXA
                                       WHERE IDTIPOMOVIVE <> 'T' )MV,
                                      ITEMVENDA IT LEFT JOIN (SELECT CDFILIAL, CDCAIXA, NRSEQVENDA, NRSEQUITVEND
                                                              FROM ITVENDAIMPOS IV, IMPOSTO I
                                                              WHERE IV.CDIMPOSTO    = I.CDIMPOSTO  AND
                                                                    I.IDTPIMPOSFIS <> 'S' ) IP ON (IT.CDFILIAL     = IP.CDFILIAL)      AND
                                                                                                  (IT.CDCAIXA      = IP.CDCAIXA)       AND
                                                                                                  (IT.NRSEQVENDA   = IP.NRSEQVENDA)    AND
                                                                                                  (IT.NRSEQUITVEND = IP.NRSEQUITVEND)

                                 WHERE FI.CDEMPRESA    = @P_CDEMPRESA        AND
                                       FI.CDINSCESTA   = @P_CDINSCESTA       AND
                                       VD.CDFILIAL     = FI.CDFILIAL         AND
                                       VD.IDSITUVENDA  = 'O'                 AND
                                       VD.DTENTRVENDA BETWEEN @P_DTINICIAL   AND @P_DTFINAL AND
                                       VD.CDFILIAL     = IT.CDFILIAL         AND
                                       VD.CDCAIXA      = IT.CDCAIXA          AND
                                       VD.NRSEQVENDA   = IT.NRSEQVENDA       AND
                                       FI.CDFILIAL     = P.CDFILIAL          AND
                                       VD.CDFILIAL     = MV.CDFILIAL         AND
                                       VD.CDCAIXA      = MV.CDCAIXA          AND
                                       VD.NRSEQVENDA   = MV.NRSEQVENDA
                                 GROUP BY
                                    VD.CDEMPRESA, FI.CDINSCESTA, FI.CDINSCMUNI, FI.CDFILIAL, VD.DTENTRVENDA, P.NRTAMNUMNFUT)

   OPEN C_CORPONF;

   FETCH NEXT FROM C_CORPONF INTO @C_CORPONF_CDEMPRESA,  @C_CORPONF_CDINSCESTA,  @C_CORPONF_CDINSCMUNI,
                                  @C_CORPONF_CDFILIAL,   @C_CORPONF_DTENTRVENDA, @C_CORPONF_NRTAMNUMNFUT,
                                  @C_CORPONF_NRCUPOMFIM, @C_CORPONF_NRCUPOMINI,  @C_CORPONF_VRVENDA;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT @V_NRNOTAANTE = MAX(NRNOTAFISC)
      FROM NOTAFISCAL
      WHERE CDEMPRESA  = @P_CDEMPRESA           AND
            CDINSCESTA = @P_CDINSCESTA          AND
            DTEMISSAO  = @C_CORPONF_DTENTRVENDA AND
            IDENTRSAIDOP = 'S'                  AND
            IDSISTEMA  = 'FIS'                  AND
            CDSERIE    = 'ECF'                  AND
            CDFILIEMIT = @C_CORPONF_CDFILIAL    AND
            DTEXPORTACAO IS NOT NULL;

      SELECT V_CDMODDOCFISC = MIN(CDMODDOCFISC)
        FROM MODDOCFISCTPOP
       WHERE CDTIPOOPER   = @P_CDOPERACAO
         AND IDENTRSAIDOP = 'S';

      SELECT @V_FILIPROC = MAX(CDFILIAL)
      FROM PARAMGERAL;

      UPDATE MAPARESUMECF
      SET CDFILIALNF = NULL,
          NRLANCTONF = NULL
      WHERE CDFILIAL     = @C_CORPONF_CDFILIAL     AND
            DTMAPARESECF = @C_CORPONF_DTENTRVENDA  AND
            NRMAPARESECF = @V_NRNOTAANTE;

      DELETE FROM IMPOSTONF
      WHERE (CDFILIAL+NRLANCTONF) IN (SELECT CDFILIAL+NRLANCTONF
                                       FROM NOTAFISCAL
                                       WHERE CDEMPRESA  = @P_CDEMPRESA           AND
                                             CDINSCESTA = @P_CDINSCESTA          AND
                                             DTEMISSAO  = @C_CORPONF_DTENTRVENDA AND
                                             IDENTRSAIDOP = 'S'                  AND
                                             IDSISTEMA  = 'FIS'                  AND
                                             CDSERIE    = 'ECF'                  AND
                                             CDFILIEMIT = @C_CORPONF_CDFILIAL    AND
                                             DTEXPORTACAO IS NOT NULL);

      DELETE FROM NOTAFISCAL
      WHERE (CDFILIAL+NRLANCTONF) IN (SELECT CDFILIAL+NRLANCTONF
                                        FROM NOTAFISCAL
                                       WHERE CDEMPRESA  = @P_CDEMPRESA           AND
                                             CDINSCESTA = @P_CDINSCESTA          AND
                                             DTEMISSAO  = @C_CORPONF_DTENTRVENDA AND
                                             IDENTRSAIDOP = 'S'                  AND
                                             IDSISTEMA  = 'FIS'                  AND
                                             CDSERIE    = 'ECF'                  AND
                                             CDFILIEMIT = @C_CORPONF_CDFILIAL    AND
                                             DTEXPORTACAO IS NOT NULL);

      SET @V_CONTADOR = 'LANCNF/FILIAL' + @V_FILIPROC;
      EXEC NOVO_CODIGO @V_CONTADOR,
                       @P_SEQUENCIAL = @V_NRLANCTONF OUTPUT;

      SET @V_NRLANCTONF = SUBSTRING(@V_NRLANCTONF, 11, 10);

      IF @V_NRNOTAANTE IS NULL BEGIN
         SELECT @V_NRNOTAFISC = MAX(NRMAPARESECF)
         FROM MAPARESUMECF
         WHERE CDFILIAL     = @C_CORPONF_CDFILIAL     AND
               DTMAPARESECF = @C_CORPONF_DTENTRVENDA;

         IF @V_NRNOTAFISC IS NULL BEGIN
            SET @V_CONTADOR = 'MODELONF' + @P_CDCTRLNUMENF;
            EXEC NOVO_CODIGO @V_CONTADOR ,
                             @P_SEQUENCIAL = @V_NRNOTAFISC OUTPUT;

            IF @C_CORPONF_NRTAMNUMNFUT IS NULL BEGIN
               SET @V_TAMNF = 7;
            END
            ELSE BEGIN
               SET @V_TAMNF = @C_CORPONF_NRTAMNUMNFUT;
            END;

            SET @V_NRNOTAFISC = RIGHT(REPLICATE('0', @V_TAMNF) + @V_NRNOTAFISC, @V_TAMNF);
         END;
      END
      ELSE BEGIN
         SET @V_NRNOTAFISC = @V_NRNOTAANTE;
      END;

      SELECT @V_CDCLIENTE = MAX(P.CDCLIENTE),
             @V_IDTPIJURNF = MAX(C.IDTPIJURCLIE),
             @V_NRINSJURNF = MAX(C.NRINSJURCLIE)
      FROM PARAVEND P, CLIENTE C
      WHERE P.CDFILIAL  = @C_CORPONF_CDFILIAL AND
            C.CDCLIENTE = P.CDCLIENTE;

      SELECT @V_FILIPROC = MAX(CDFILIAL)
      FROM PARAMGERAL;

      SELECT @V_IDENDEMIS = ISNULL(MAX(IDENDCFOPCLI),'P')
      FROM CLIENTE
      WHERE (CDCLIENTE = @V_CDCLIENTE);

      SELECT @V_PAISORIG = MAX(CDPAIS),
             @V_ESTAORIG = MAX(SGESTADO),
             @V_MUNIORIG = MAX(CDMUNICIPIO)
      FROM INSCRESTAD
      WHERE (CDEMPRESA  = @P_CDEMPRESA) AND
            (CDINSCESTA = @P_CDINSCESTA) ;

      SELECT @V_PAISDEST = MAX(CDPAIS),
             @V_ESTADEST = MAX(SGESTADO)
      FROM ENDECLIE
      WHERE (CDCLIENTE    = @V_CDCLIENTE) AND
            (IDTPENDECLIE = @V_IDENDEMIS);

      SET @V_IDINTEREST = 'N';
      SET @V_IDINTERNA  = 'N';
      IF ((@V_PAISDEST = @V_PAISORIG) AND (@V_ESTADEST <> @V_ESTAORIG)) BEGIN
         SET @V_IDINTEREST = 'S';
      END;

      IF (@V_PAISDEST <> @V_PAISORIG) BEGIN
         SET @V_IDINTERNA = 'S';
      END;

      INSERT INTO NOTAFISCAL
         (CDFILIAL,     NRLANCTONF,   CDEMPRESA,    CDINSCESTA,   CDINSCMUNI,
          CDFILIEMIT,   IDBLOQUEADO,  IDDOCFISCAL,  IDDOCFINANC,  NRNOTAFISC,
          DTEMISSAO,    DTENTRSAID,   VRPRODUTOS,   VRNOTAFISC,   IDENTRSAIDOP,
          CDTIPOOPER,   CDSERIE,      IDDOCCONTAB,  IDSTATUS,     IDDOCFATUR,
          IDDOCFISCENT, IDDOCFISCSAI, IDDOCESTOQUE, IDSISTEMA,    IDORIGDESTNF,
          DTEXPORTACAO, CDCLIENTE,    IDTPIJURNF,   NRINSJURNF,   CDMODDOCFISC)
      VALUES
         (@V_FILIPROC, @V_NRLANCTONF, @P_CDEMPRESA, @P_CDINSCESTA, @C_CORPONF_CDINSCMUNI,
          @C_CORPONF_CDFILIAL,  'S', 'S', 'N', @V_NRNOTAFISC,
          @C_CORPONF_DTENTRVENDA, @C_CORPONF_DTENTRVENDA, ISNULL(@C_CORPONF_VRVENDA,0), ISNULL(@C_CORPONF_VRVENDA,0), 'S',
          @P_CDOPERACAO, 'ECF', 'N', 'A', 'N',
          'N', 'N', 'N', 'FIS', 'C',
          @C_CORPONF_DTENTRVENDA, @V_CDCLIENTE, @V_IDTPIJURNF, @V_NRINSJURNF, @V_CDMODDOCFISC);

      SET @V_SEQUIMPOSTNF = '01';

      SET @V_ALIQTEMP = @V_FILIPROC+@V_NRLANCTONF;
      SET @V_INCITEMP = @V_FILIPROC+@V_NRLANCTONF;
      SET @V_CSTTEMP  = @V_FILIPROC+@V_NRLANCTONF;
      SET @V_CFOPTEMP = @V_FILIPROC+@V_NRLANCTONF;

      EXEC CONSULTA_GRUPOFISCAL 'C', @V_CDCLIENTE, @C_CORPONF_CDFILIAL, 'S', @P_CDOPERACAO, @V_CDGRUPOFISC;

      DECLARE C_ITEMFISC CURSOR FOR (SELECT CDEMPRESA, DTENTRVENDA, CDFILIAL,IDTPIMPOSFIS,CDCSTPROD,CFOPITEM,VRPEALPRODIT, SUM(VRUNIT), SUM(BASECALC), SUM(VRIMPOSTO)
                                       FROM
                                          (SELECT VD.CDEMPRESA, VD.DTENTRVENDA, VD.CDFILIAL, ISNULL(IP.IDTPIMPOSFIS,'F') AS IDTPIMPOSFIS,
                                                  TEKNISA.CST_ITEM_VENDA(VD.CDEMPRESA, @P_CDINSCESTA, VD.CDFILIAL, @V_NRLANCTONF, @V_CDCLIENTE, @P_CDOPERACAO, P.CDARVPROD) AS CDCSTPROD,
                                                  TEKNISA.CFOP_ITEM_VENDA(VD.CDEMPRESA, @P_CDINSCESTA, VD.CDFILIAL, @V_CDCLIENTE, @P_CDOPERACAO, VD.DTENTRVENDA, P.CDARVPROD, @V_PAISORIG, @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST) AS CFOPITEM,
                                                  ISNULL(IP.VRPEALPRODIT,0) AS VRPEALPRODIT, SUM(ROUND(IT.VRUNITVEND+VRUNITVENDCL,2,1)) AS VRUNIT,
                                                  SUM(ROUND((IT.QTPRODVEND * (IT.VRUNITVEND+IT.VRUNITVENDCL)),2,1)- ISNULL(IT.VRDESITVEND,0) + ISNULL(IT.VRACRITVEND,0)) AS BASECALC,
                                                  ROUND(SUM(((IT.QTPRODVEND * (IT.VRUNITVEND+IT.VRUNITVENDCL))-ISNULL(IT.VRDESITVEND,0) + ISNULL(IT.VRACRITVEND,0)) * (IP.VRPEALPRODIT/100)),2,1) AS VRIMPOSTO,
                                                  VD.CDCAIXA
                                             FROM VENDA VD, ITEMVENDA IT, PRODUTO P,
                                                 (SELECT DISTINCT CDFILIAL, CDCAIXA, NRSEQVENDA
                                                    FROM MOVCAIXA
                                                   WHERE IDTIPOMOVIVE <> 'T' )MV,
                                                 (SELECT CDFILIAL, CDCAIXA, NRSEQVENDA, NRSEQUITVEND, IDTPIMPOSFIS, VRPEALPRODIT
                                                    FROM ITVENDAIMPOS IV, IMPOSTO I
                                                   WHERE IV.CDIMPOSTO    = I.CDIMPOSTO AND
                                                      I.IDTPIMPOSFIS <> 'S' ) IP
                                            WHERE VD.CDEMPRESA    = @C_CORPONF_CDEMPRESA   AND
                                                  VD.CDFILIAL     = @C_CORPONF_CDFILIAL    AND
                                                  VD.IDSITUVENDA  = 'O'                    AND
                                                  VD.DTENTRVENDA  = @C_CORPONF_DTENTRVENDA AND
                                                  VD.CDFILIAL     = IT.CDFILIAL            AND
                                                  VD.CDCAIXA      = IT.CDCAIXA             AND
                                                  VD.NRSEQVENDA   = IT.NRSEQVENDA          AND
                                                  VD.CDFILIAL     = MV.CDFILIAL            AND
                                                  VD.CDCAIXA      = MV.CDCAIXA             AND
                                                  VD.NRSEQVENDA   = MV.NRSEQVENDA          AND
                                                  IT.CDPRODUTO    = P.CDPRODUTO            AND
                                                  IT.CDFILIAL     = IP.CDFILIAL            AND
                                                  IT.CDCAIXA      = IP.CDCAIXA             AND
                                                  IT.NRSEQVENDA   = IP.NRSEQVENDA          AND
                                                  IT.NRSEQUITVEND = IP.NRSEQUITVEND
                                            GROUP BY
                                                  VD.CDEMPRESA, VD.CDFILIAL, VD.DTENTRVENDA, ISNULL(IP.IDTPIMPOSFIS,'F'), ISNULL(IP.VRPEALPRODIT,0),
                                                  TEKNISA.CST_ITEM_VENDA(VD.CDEMPRESA, @P_CDINSCESTA, VD.CDFILIAL, @V_NRLANCTONF, @V_CDCLIENTE, @P_CDOPERACAO, P.CDARVPROD),
                                                  TEKNISA.CFOP_ITEM_VENDA(VD.CDEMPRESA, @P_CDINSCESTA, VD.CDFILIAL, @V_CDCLIENTE, @P_CDOPERACAO, VD.DTENTRVENDA, P.CDARVPROD, @V_PAISORIG, @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST),VD.CDCAIXA)T
                                      GROUP BY CDEMPRESA, DTENTRVENDA, CDFILIAL, IDTPIMPOSFIS, CDCSTPROD,CFOPITEM,VRPEALPRODIT)

      OPEN C_ITEMFISC;

      FETCH NEXT FROM C_ITEMFISC INTO @C_ITEMFISC_CDEMPRESA, @C_ITEMFISC_DTENTRVENDA, @C_ITEMFISC_CDFILIAL, @C_ITEMFISC_IDTPIMPOSFIS,
                                      @C_ITEMFISC_CDCSTPROD, @C_ITEMFISC_CFOPITEM, @C_ITEMFISC_VRPEALPRODIT,  @C_ITEMFISC_VRUNIT,
                                      @C_ITEMFISC_BASECALC, @C_ITEMFISC_VRIMPOSTO;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         IF (@C_ITEMFISC_IDTPIMPOSFIS = 'T') BEGIN
            SET @V_INCIDENCIA = '1';
            SET @V_BASECALC   = @C_ITEMFISC_BASECALC;
         END
         ELSE BEGIN
            IF (@C_ITEMFISC_IDTPIMPOSFIS = 'F') BEGIN
               SET @V_INCIDENCIA = '3';
               SET @V_BASECALC = 0;
            END
            ELSE BEGIN
               SET @V_INCIDENCIA = '2';
               SET @V_BASECALC = 0;
            END;
         END;

         IF @V_SEQUIMPOSTNF = '01' BEGIN
            IF ISNULL(@C_CORPONF_NRCUPOMINI,'T') = ISNULL(@C_CORPONF_NRCUPOMFIM,'T') BEGIN
               SET @V_DSOBSFISCIT  = 'NF Subst. CF '+@C_CORPONF_NRCUPOMINI;
            END
            ELSE BEGIN
               IF (@C_CORPONF_NRCUPOMINI+@C_CORPONF_NRCUPOMFIM IS NOT NULL) BEGIN
                  SET @V_DSOBSFISCIT  = 'NF Subst. CF '+@C_CORPONF_NRCUPOMINI+'/'+@C_CORPONF_NRCUPOMFIM;
               END
               ELSE BEGIN
                  SET @V_DSOBSFISCIT  = '';
               END;
            END;
         END
         ELSE BEGIN
            SET @V_DSOBSFISCIT  = '';
         END;

         INSERT INTO IMPOSTONF
            (CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF,  VRPERREDBCNF, VRBASECALCNF,
             VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, IDIMPOSTONF, DSOBSFISCIT)
         VALUES
            (@V_FILIPROC, @V_NRLANCTONF, '00', @V_SEQUIMPOSTNF, ISNULL(@C_ITEMFISC_BASECALC,0), 0.00, @V_BASECALC,
             ISNULL(@C_ITEMFISC_VRPEALPRODIT,0), 0.00, ISNULL(@C_ITEMFISC_VRIMPOSTO,0), @V_INCIDENCIA, @C_ITEMFISC_CDCSTPROD,
             SUBSTRING(@C_ITEMFISC_CFOPITEM,3,14), '1', @V_DSOBSFISCIT);

         SET @V_SEQUIMPOSTNF = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC,@V_SEQUIMPOSTNF) + 1)),2);

         FETCH NEXT FROM C_ITEMFISC INTO @C_ITEMFISC_CDEMPRESA, @C_ITEMFISC_DTENTRVENDA, @C_ITEMFISC_CDFILIAL, @C_ITEMFISC_IDTPIMPOSFIS,
                                      @C_ITEMFISC_CDCSTPROD, @C_ITEMFISC_CFOPITEM, @C_ITEMFISC_VRPEALPRODIT,  @C_ITEMFISC_VRUNIT,
                                      @C_ITEMFISC_BASECALC, @C_ITEMFISC_VRIMPOSTO;
      END;

      UPDATE MAPARESUMECF
      SET CDFILIALNF = @V_FILIPROC,
          NRLANCTONF = @V_NRLANCTONF
      WHERE CDFILIAL     = @C_CORPONF_CDFILIAL     AND
            DTMAPARESECF = @C_CORPONF_DTENTRVENDA  AND
            NRMAPARESECF = @V_NRNOTAFISC;

      CLOSE C_ITEMFISC;
      DEALLOCATE C_ITEMFISC;


      SET @V_NRSEQUITVEND = '01';

      DECLARE C_OUTROSIMP CURSOR FOR (SELECT P.CDARVPROD,
                                             SUM(ROUND((I.QTPRODVEND * (I.VRUNITVEND+I.VRUNITVENDCL)),2,1)-ISNULL(I.VRDESITVEND,0)+ ISNULL(I.VRACRITVEND,0)) AS VRLIQUIITEM
                                      FROM VENDA V, ITEMVENDA I, PRODUTO P,
                                           (SELECT DISTINCT CDFILIAL, CDCAIXA, NRSEQVENDA
                                            FROM MOVCAIXA
                                            WHERE IDTIPOMOVIVE <> 'T' )M
                                      WHERE V.CDEMPRESA    = @C_CORPONF_CDEMPRESA   AND
                                            V.CDFILIAL     = @C_CORPONF_CDFILIAL    AND
                                            V.IDSITUVENDA  = 'O'                    AND
                                            V.DTENTRVENDA  = @C_CORPONF_DTENTRVENDA AND
                                            V.CDFILIAL     = I.CDFILIAL             AND
                                            V.CDCAIXA      = I.CDCAIXA              AND
                                            V.NRSEQVENDA   = I.NRSEQVENDA           AND
                                            I.CDPRODUTO    = P.CDPRODUTO            AND
                                            V.CDFILIAL     = M.CDFILIAL             AND
                                            V.CDCAIXA      = M.CDCAIXA              AND
                                            V.NRSEQVENDA   = M.NRSEQVENDA
                                      GROUP BY P.CDARVPROD)

      OPEN C_OUTROSIMP;

      FETCH NEXT FROM C_OUTROSIMP INTO @C_OUTROSIMP_CDARVPROD, @C_OUTROSIMP_VRLIQUIITEM;

      WHILE (@@FETCH_STATUS = 0) BEGIN

          EXEC CONSULTA_GRUPOFISCAL 'C', @V_CDCLIENTE, '', 'S', @P_CDOPERACAO, @V_CDGRUPOFISC;

          EXEC CONSULTA_INCIDENCIA 'S', @P_CDEMPRESA, @C_OUTROSIMP_CDARVPROD, @P_CDINSCESTA, @P_CDOPERACAO, @V_FILIPROC, @V_NRLANCTONF, @V_CDGRUPOFISC;

          EXEC CONSULTA_CST 'S', @P_CDEMPRESA, @C_OUTROSIMP_CDARVPROD, @P_CDINSCESTA, @P_CDOPERACAO, @V_FILIPROC, @V_NRLANCTONF, @V_CDGRUPOFISC, @V_IDINTEREST, @V_IDINTERNA;

          EXEC CONSULTA_CFOP 'S', @P_CDEMPRESA, @C_OUTROSIMP_CDARVPROD, @P_CDINSCESTA, @P_CDOPERACAO, @V_PAISORIG,
                              @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_FILIPROC, @V_NRLANCTONF, @V_CDGRUPOFISC, @C_CORPONF_DTENTRVENDA;

          SELECT @V_SITUTRIBPR = MAX(CDSITTRIBTMP)
          FROM CSTTEMP
          WHERE (NRCSTTEMP = @V_CSTTEMP);

          SELECT @V_FISOPEITEM = MAX(CDFISOPETMP)
          FROM CFOPTEMP
          WHERE NRCFOPTEMP = @V_CFOPTEMP;

          DECLARE C_INCIDENCIA CURSOR FOR (SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP, IDTRATIMPTMP,
                                                  IDCONSISTENT, IDIMPORECUP
                                           FROM INCITEMP IT, IMPOSTO IP
                                           WHERE (IT.NRINCITEMP = @V_INCITEMP)    AND
                                                 (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
                                                 (IP.CDIMPOSTO  <> '00')         AND
                                                 (IP.IDPRODNOTA = 'P'))
          OPEN C_INCIDENCIA;

          FETCH NEXT FROM C_INCIDENCIA INTO @C_INCIDENCIA_CDIMPOTEMP, @C_INCIDENCIA_CDFISCTEMP, @C_INCIDENCIA_IDTRATIMPTMP,
                                            @C_INCIDENCIA_IDCONSISTENT, @C_INCIDENCIA_IDIMPORECUP;


          WHILE (@@FETCH_STATUS = 0) BEGIN

               EXEC CONSULTA_ALIQUOTA @C_INCIDENCIA_CDIMPOTEMP, 'S', @P_CDEMPRESA, @C_OUTROSIMP_CDARVPROD, @P_CDINSCESTA, @V_PAISORIG,
                                      @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @C_OUTROSIMP_VRLIQUIITEM, @C_CORPONF_DTENTRVENDA,
                                      @V_FILIPROC, @V_NRLANCTONF, @V_CDGRUPOFISC;

               SET @V_NRALIQTEMP = 0;
               SET @V_PARDEDTMP  = 0;
               SET @V_PREDBCTMP  = 0;
               SET @V_ALIQUTMP   = 0;
               SET @V_IMPOSTOIT  = 0;

               SELECT @V_NRALIQTEMP = ISNULL(MAX(NRALIQTEMP),0),
                      @V_PARDEDTMP  = ISNULL(MAX(VRPARDEDTMP),0),
                      @V_PREDBCTMP  = ISNULL(MAX(VRPREDBCTMP),0),
                      @V_ALIQUTMP   = ISNULL(MAX(VRALIQUTMP),0),
                      @V_TRATIMPST  = ISNULL(MAX(IDTRIMPSTTMP), '0')
               FROM ALIQTEMP
               WHERE (NRALIQTEMP = @V_ALIQTEMP);

               SET @V_TAXABASECALC = (100 - @V_PREDBCTMP)/100;
               SET @V_TAXAALIQUOTA = (@V_ALIQUTMP/100);

               SET @V_BASECALCIT   = @C_OUTROSIMP_VRLIQUIITEM * @V_TAXABASECALC;
               SET @V_PERDBCALC    = 100 - @V_PREDBCTMP;

               SET @V_IMPOSTOIT   = (@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP;
               SET @V_IDTRIMPSTII = @V_TRATIMPST;
               SET @V_CONTABCALC  = @V_LIQUIITEM - (@V_LIQUIITEM * @V_TAXABASECALC);

               IF (@V_IMPOSTOIT < 0) BEGIN
                  SET @V_IMPOSTOIT = 0;
               END;

               INSERT INTO TRABITPROIMPOS(
                  CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT,
                  CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT,
                  VRCONTIMPOIT, VRBCALCIMPOIT, VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT, IDVALORINFO, IDTRIMPSTTI)
               VALUES(
                  @V_FILIPROC, @V_NRLANCTONF, @V_NRSEQUITVEND, @C_INCIDENCIA_CDIMPOTEMP, '1', @C_INCIDENCIA_CDFISCTEMP,
                  @V_SITUTRIBPR, @V_FISOPEITEM, '', @V_ALIQUTMP, @V_PREDBCTMP, @V_PARDEDTMP, @V_BASECALCIT,
                  @V_BASECALCIT, @V_IMPOSTOIT, '00000', '00000', 'N', @V_IDTRIMPSTII);

               SET @V_NRSEQUITVEND = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC,@V_NRSEQUITVEND) + 1)),2);

               DELETE ALIQTEMP
               WHERE NRALIQTEMP = @V_ALIQTEMP;

             FETCH NEXT FROM C_INCIDENCIA INTO @C_INCIDENCIA_CDIMPOTEMP, @C_INCIDENCIA_CDFISCTEMP, @C_INCIDENCIA_IDTRATIMPTMP,
                                            @C_INCIDENCIA_IDCONSISTENT, @C_INCIDENCIA_IDIMPORECUP;
          END;

          CLOSE C_INCIDENCIA;
          DEALLOCATE C_INCIDENCIA;

          DELETE INCITEMP
          WHERE NRINCITEMP = @V_INCITEMP;

          DELETE CFOPTEMP
          WHERE NRCFOPTEMP = @V_CFOPTEMP;

          DELETE CSTTEMP
          WHERE NRCSTTEMP = @V_CSTTEMP;

         FETCH NEXT FROM C_OUTROSIMP INTO @C_OUTROSIMP_CDARVPROD, @C_OUTROSIMP_VRLIQUIITEM;
      END;

      CLOSE C_OUTROSIMP;
      DEALLOCATE C_OUTROSIMP;

      SET @V_SEQUIMPOSTNF = '01';

      DECLARE C_IMPOSTONF CURSOR FOR (SELECT IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
                                             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
                                             SUM(VRBCALCIMPOIT) AS VRBCALCIMPOIT, SUM(VRIMPOSIT) AS VRIMPOSIT
                                      FROM TRABITPROIMPOS IT, IMPOSTO I
                                      WHERE (CDFILIMPOIT  = @V_FILIPROC)    AND
                                            (NRLANCIMPOIT = @V_NRLANCTONF)  AND
                                            (CDIMPOSTOIT  = I.CDIMPOSTO) AND
                                            ((((CDFISCIMPOIT = '1')) AND (IDIMPORECUP = 'S')) OR
                                             ((IDIMPORECUP <> 'S') AND (VRIMPOSIT <> 0)) OR (NRSEQITPRO = '3'))
                                      GROUP BY IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
                                               CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO
                                      UNION
                                      SELECT IT.CDIMPOSTOIT, 0 AS VRALIQIMPOIT, 0 AS VRREDBCIMPOIT, 0 AS VRPDEDIMPOIT, CDFISCIMPOIT,
                                             CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
                                             0 AS VRBCALCIMPOIT, 0 AS VRIMPOSIT
                                      FROM TRABITPROIMPOS IT, IMPOSTO I
                                      WHERE (CDFILIMPOIT  = @V_FILIPROC)    AND
                                            (NRLANCIMPOIT = @V_NRLANCTONF)  AND
                                            (CDIMPOSTOIT  = I.CDIMPOSTO) AND
                                            (NRSEQITPRO   <> '3')        AND
                                            ((((CDFISCIMPOIT <> '1')) AND (IDIMPORECUP = 'S')) OR
                                             ((IDIMPORECUP  <> 'S') AND (VRIMPOSIT = 0)))
                                      GROUP BY IT.CDIMPOSTOIT, CDFISCIMPOIT, CDSTRIBIMPOIT,
                                               CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO)

      OPEN C_IMPOSTONF;

      FETCH NEXT FROM C_IMPOSTONF INTO  @C_IMPOSTONF_CDIMPOSTOIT, @C_IMPOSTONF_VRALIQIMPOIT, @C_IMPOSTONF_VRREDBCIMPOIT,
                                        @C_IMPOSTONF_VRPDEDIMPOIT, @C_IMPOSTONF_CDFISCIMPOIT, @C_IMPOSTONF_CDSTRIBIMPOIT,
                                        @C_IMPOSTONF_CDFOPERIMPOIT, @C_IMPOSTONF_CDSCFOPIMPOIT, @C_IMPOSTONF_NRSEQITPRO,
                                        @C_IMPOSTONF_VRCONTIMPOIT, @C_IMPOSTONF_VRBCALCIMPOIT, @C_IMPOSTONF_VRIMPOSIT;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         INSERT INTO IMPOSTONF(
            CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
            VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF,
            IDIMPOSTONF)
         VALUES(
            @V_FILIPROC, @V_NRLANCTONF, @C_IMPOSTONF_CDIMPOSTOIT, @V_SEQUIMPOSTNF, @C_IMPOSTONF_VRCONTIMPOIT,
            @C_IMPOSTONF_VRREDBCIMPOIT, @C_IMPOSTONF_VRBCALCIMPOIT, @C_IMPOSTONF_VRALIQIMPOIT,
            @C_IMPOSTONF_VRPDEDIMPOIT, @C_IMPOSTONF_VRIMPOSIT, @C_IMPOSTONF_CDFISCIMPOIT,
            @C_IMPOSTONF_CDSTRIBIMPOIT, @C_IMPOSTONF_CDFOPERIMPOIT, @C_IMPOSTONF_CDSCFOPIMPOIT,
            @C_IMPOSTONF_NRSEQITPRO);

         SET @V_SEQUIMPOSTNF = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC,@V_SEQUIMPOSTNF) + 1)),2);

         FETCH NEXT FROM C_IMPOSTONF INTO  @C_IMPOSTONF_CDIMPOSTOIT, @C_IMPOSTONF_VRALIQIMPOIT, @C_IMPOSTONF_VRREDBCIMPOIT,
                                        @C_IMPOSTONF_VRPDEDIMPOIT, @C_IMPOSTONF_CDFISCIMPOIT, @C_IMPOSTONF_CDSTRIBIMPOIT,
                                        @C_IMPOSTONF_CDFOPERIMPOIT, @C_IMPOSTONF_CDSCFOPIMPOIT, @C_IMPOSTONF_NRSEQITPRO,
                                        @C_IMPOSTONF_VRCONTIMPOIT, @C_IMPOSTONF_VRBCALCIMPOIT, @C_IMPOSTONF_VRIMPOSIT;
      END;

      CLOSE C_IMPOSTONF;
      DEALLOCATE C_IMPOSTONF;

      DELETE TRABITPROIMPOS
      WHERE (CDFILIMPOIT  = @V_FILIPROC) AND
            (NRLANCIMPOIT = @V_NRLANCTONF);

      FETCH NEXT FROM C_CORPONF INTO @C_CORPONF_CDEMPRESA,  @C_CORPONF_CDINSCESTA,  @C_CORPONF_CDINSCMUNI,
                                  @C_CORPONF_CDFILIAL,   @C_CORPONF_DTENTRVENDA, @C_CORPONF_NRTAMNUMNFUT,
                                  @C_CORPONF_NRCUPOMFIM, @C_CORPONF_NRCUPOMINI,  @C_CORPONF_VRVENDA;

   END;
   CLOSE C_CORPONF;
   DEALLOCATE C_CORPONF;

   DECLARE C_LANC CURSOR FOR (SELECT IT.CDFILIALNF, IT.NRLANCTONF, MAX(VD.NRCUPOMFIS) NRCUPOMFIM, MIN(VD.NRCUPOMFIS) NRCUPOMINI
                              FROM  VENDA VD, FILIAL FI, ITEMVENDA IT, NOTAFISCAL NF,
                                   (SELECT DISTINCT CDFILIAL, CDCAIXA, NRSEQVENDA
                                    FROM MOVCAIXA
                                    WHERE IDTIPOMOVIVE <> 'T' )MV
                              WHERE FI.CDEMPRESA    = @P_CDEMPRESA       AND
                                    FI.CDINSCESTA   = @P_CDINSCESTA      AND
                                    VD.CDFILIAL     = FI.CDFILIAL        AND
                                    VD.IDSITUVENDA  = 'O'                AND
                                    VD.DTENTRVENDA BETWEEN @P_DTINICIAL  AND @P_DTFINAL AND
                                    VD.CDFILIAL     = IT.CDFILIAL        AND
                                    VD.CDCAIXA      = IT.CDCAIXA         AND
                                    VD.NRSEQVENDA   = IT.NRSEQVENDA      AND
                                    VD.CDFILIAL     = MV.CDFILIAL        AND
                                    VD.CDCAIXA      = MV.CDCAIXA         AND
                                    VD.NRSEQVENDA   = MV.NRSEQVENDA      AND
                                    IT.CDFILIALNF   = NF.CDFILIAL        AND
                                    IT.NRLANCTONF   = NF.NRLANCTONF      AND
                                    NF.IDSTATUS IN ('A', 'E')
                              GROUP BY IT.CDFILIALNF, IT.NRLANCTONF)

   OPEN C_LANC;

   FETCH NEXT FROM C_LANC INTO @C_LANC_CDFILIALNF, @C_LANC_NRLANCTONF,
                               @C_LANC_NRCUPOMFIM, @C_LANC_NRCUPOMINI;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF ISNULL(@C_LANC_NRCUPOMINI,'T') = ISNULL(@C_LANC_NRCUPOMFIM,'T') BEGIN
         UPDATE IMPOSTONF
         SET VRCONTABILNF = 0.00,
             VRBASECALCNF = 0.00,
             VRALIQNF     = 0.00,
             VRIMPOSTONF  = 0.00,
             VRPERREDBCNF = 0.00,
             CDFISCALNF   = '3',
             DSOBSFISCIT  = 'Ref.Cupom: '+@C_LANC_NRCUPOMINI
         WHERE CDFILIAL   = @C_LANC_CDFILIALNF AND
               NRLANCTONF = @C_LANC_NRLANCTONF AND
               CDIMPOSTO  = '00';
      END
      ELSE BEGIN

         UPDATE IMPOSTONF
         SET VRCONTABILNF = 0.00,
             VRBASECALCNF = 0.00,
             VRALIQNF     = 0.00,
             VRIMPOSTONF  = 0.00,
             VRPERREDBCNF = 0.00,
             CDFISCALNF   = '3',
             DSOBSFISCIT  = 'Ref. Cupom: '+@C_LANC_NRCUPOMINI+' a '+@C_LANC_NRCUPOMFIM
         WHERE CDFILIAL   = @C_LANC_CDFILIALNF AND
               NRLANCTONF = @C_LANC_NRLANCTONF AND
               CDIMPOSTO  = '00';
      END;

      FETCH NEXT FROM C_LANC INTO @C_LANC_CDFILIALNF, @C_LANC_NRLANCTONF,
                               @C_LANC_NRCUPOMFIM, @C_LANC_NRCUPOMINI;
   END;
   CLOSE C_LANC;
   DEALLOCATE C_LANC;

   /*ROTINA PARA GERAO DO MAPA RESUMO PARA AS NF'S QUE AO SER EMITIDAS GERAM CUPOM FISCAL */
   DECLARE C_NOTAFISCAL CURSOR FOR (SELECT NF.CDEMPRESA, NF.CDINSCESTA, NF.CDINSCMUNI, NF.CDFILIEMIT, NF.DTEMISSAO,
                                           P.NRTAMNUMNFUT, SUM(NF.VRNOTAFISC) VRNOTAFISC
                                    FROM NOTAFISCAL NF, SERIENF S, PARAMFILIAL P
                                    WHERE NF.CDEMPRESA    = @P_CDEMPRESA    AND
                                          NF.CDINSCESTA   = @P_CDINSCESTA   AND
                                          NF.DTEMISSAO BETWEEN @P_DTINICIAL AND @P_DTFINAL AND
                                          NF.IDENTRSAIDOP = 'S'             AND
                                          NF.IDSTATUS IN ('A', 'E')         AND
                                          ISNULL(NF.IDSISTEMA, 'DFS') NOT IN ('REC', 'PAG', 'CMP', 'SUP') AND
                                          NF.CDFILIEMIT   = P.CDFILIAL      AND
                                          NF.CDEMPRESA    = S.CDEMPRESA     AND
                                          NF.CDINSCESTA   = S.CDINSCESTA    AND
                                          NF.CDINSCMUNI   = S.CDINSCMUNI    AND
                                          NF.CDSERIE      = S.CDSERIE       AND
                                          S.IDUTLEMCUPOM  = 'S'
                                    GROUP BY NF.CDEMPRESA, NF.CDINSCESTA, NF.CDINSCMUNI, NF.CDFILIEMIT, NF.DTEMISSAO, P.NRTAMNUMNFUT)
   OPEN C_NOTAFISCAL;

   FETCH NEXT FROM C_NOTAFISCAL INTO @C_NOTAFISCAL_CDEMPRESA, @C_NOTAFISCAL_CDINSCESTA, @C_NOTAFISCAL_CDINSCMUNI, @C_NOTAFISCAL_CDFILIEMIT,
                                     @C_NOTAFISCAL_DTEMISSAO, @C_NOTAFISCAL_NRTAMNUMNFUT, @C_NOTAFISCAL_VRNOTAFISC;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT @V_NRNOTAANTE = MAX(NRNOTAFISC)
      FROM NOTAFISCAL
      WHERE CDEMPRESA  = @P_CDEMPRESA            AND
            CDINSCESTA = @P_CDINSCESTA           AND
            DTEMISSAO  = @C_NOTAFISCAL_DTEMISSAO AND
            IDENTRSAIDOP = 'S'                   AND
            IDSISTEMA  = 'FIS'                   AND
            CDSERIE    = 'ECF'                   AND
            DTEXPORTACAO IS NOT NULL;

      SELECT @V_LANCTEMP = MAX(NRNOTAFISC),
             @V_NRLANCTEMP = MAX(NRLANCTONF)
      FROM NOTAFISCAL
      WHERE CDEMPRESA  = @P_CDEMPRESA            AND
            CDINSCESTA = @P_CDINSCESTA           AND
            DTEMISSAO  = @C_NOTAFISCAL_DTEMISSAO AND
            IDENTRSAIDOP = 'S'                   AND
            IDSISTEMA  = 'TMP'                   AND
            CDSERIE    = 'ECF'                   AND
            DTEXPORTACAO IS NOT NULL;

      SELECT @V_FILIPROC = MAX(CDFILIAL)
      FROM PARAMGERAL;

      SET @V_CONTADOR = 'LANCNF/FILIAL' + @V_FILIPROC;
      EXEC NOVO_CODIGO @V_CONTADOR,
                       @P_SEQUENCIAL = @V_NRLANCTONF OUTPUT;

      SET @V_NRLANCTONF = SUBSTRING(@V_NRLANCTONF, 11, 10);

      SET @V_CONTADOR = 'MODELONF' + @P_CDCTRLNUMENF;
      EXEC NOVO_CODIGO @V_CONTADOR,
                       @P_SEQUENCIAL = @V_NRNOTAFISC OUTPUT;

      IF @C_NOTAFISCAL_NRTAMNUMNFUT IS NULL BEGIN
         SET @V_TAMNF = 7;
      END
      ELSE BEGIN
         SET @V_TAMNF = @C_NOTAFISCAL_NRTAMNUMNFUT;
      END;

      SET @V_NRNOTAFISC = RIGHT(REPLICATE('0', @V_TAMNF) + @V_NRNOTAFISC, @V_TAMNF);


      SELECT @V_CDCLIENTE = MAX(P.CDCLIENTE), @V_IDTPIJURNF = MAX(C.IDTPIJURCLIE),
             @V_NRINSJURNF = MAX(C.NRINSJURCLIE)
      FROM PARAVEND P, CLIENTE C
      WHERE P.CDFILIAL  = @C_NOTAFISCAL_CDFILIEMIT AND
            C.CDCLIENTE = P.CDCLIENTE;

      SELECT V_CDMODDOCFISC = MIN(CDMODDOCFISC)
        FROM MODDOCFISCTPOP
       WHERE CDTIPOOPER   = @P_CDOPERACAO
         AND IDENTRSAIDOP = 'S';

      IF NOT @V_LANCTEMP IS NULL BEGIN
         UPDATE NOTAFISCAL
         SET VRNOTAFISC = VRNOTAFISC + @C_NOTAFISCAL_VRNOTAFISC
         WHERE CDEMPRESA  = @P_CDEMPRESA            AND
               CDINSCESTA = @P_CDINSCESTA           AND
               DTEMISSAO  = @C_NOTAFISCAL_DTEMISSAO AND
               CDFILIAL   = @V_FILIPROC             AND
               NRLANCTONF = @V_NRLANCTEMP           AND
               IDENTRSAIDOP = 'S'                   AND
               IDSISTEMA  = 'TMP'                   AND
               CDSERIE    = 'ECF'                   AND
               DTEXPORTACAO IS NOT NULL;
      END
      ELSE BEGIN
         IF NOT @V_NRNOTAANTE IS NULL BEGIN
           DELETE FROM IMPOSTONF
           WHERE (CDFILIAL+NRLANCTONF)  IN (SELECT CDFILIAL+NRLANCTONF
                                            FROM NOTAFISCAL
                                            WHERE CDEMPRESA  = @P_CDEMPRESA            AND
                                                  CDINSCESTA = @P_CDINSCESTA           AND
                                                  DTEMISSAO  = @C_NOTAFISCAL_DTEMISSAO AND
                                                  IDENTRSAIDOP = 'S'                   AND
                                                  IDSISTEMA  = 'FIS'                   AND
                                                  CDSERIE    = 'ECF'                   AND
                                                  DTEXPORTACAO IS NOT NULL);

           DELETE FROM NOTAFISCAL
           WHERE (CDFILIAL+NRLANCTONF) IN (SELECT CDFILIAL+NRLANCTONF
                                             FROM NOTAFISCAL
                                            WHERE CDEMPRESA  = @P_CDEMPRESA            AND
                                                  CDINSCESTA = @P_CDINSCESTA           AND
                                                  DTEMISSAO  = @C_NOTAFISCAL_DTEMISSAO AND
                                                  IDENTRSAIDOP = 'S'                   AND
                                                  IDSISTEMA  = 'FIS'                   AND
                                                  CDSERIE    = 'ECF'                   AND
                                                  DTEXPORTACAO IS NOT NULL);
           INSERT INTO NOTAFISCAL
              (CDFILIAL,     NRLANCTONF,   CDEMPRESA,    CDINSCESTA,   CDINSCMUNI,
               CDFILIEMIT,   IDBLOQUEADO,  IDDOCFISCAL,  IDDOCFINANC,  NRNOTAFISC,
               DTEMISSAO,    DTENTRSAID,   VRPRODUTOS,   VRNOTAFISC,   IDENTRSAIDOP,
               CDTIPOOPER,   CDSERIE,      IDDOCCONTAB,  IDSTATUS,     IDDOCFATUR,
               IDDOCFISCENT, IDDOCFISCSAI, IDDOCESTOQUE, IDSISTEMA,    IDORIGDESTNF,
               DTEXPORTACAO, CDCLIENTE,    IDTPIJURNF,   NRINSJURNF,   CDMODDOCFISC)
           VALUES
              (@V_FILIPROC, @V_NRLANCTONF, @P_CDEMPRESA, @P_CDINSCESTA, @C_NOTAFISCAL_CDINSCMUNI,
               @C_NOTAFISCAL_CDFILIEMIT,  'S', 'S', 'N', @V_NRNOTAANTE,
               @C_NOTAFISCAL_DTEMISSAO, @C_NOTAFISCAL_DTEMISSAO, ISNULL(@C_NOTAFISCAL_VRNOTAFISC,0), ISNULL(@C_NOTAFISCAL_VRNOTAFISC,0), 'S',
               @P_CDOPERACAO, 'ECF', 'N', 'A', 'N', 'N', 'N', 'N', 'FIS', 'C',
               @C_NOTAFISCAL_DTEMISSAO, @V_CDCLIENTE, @V_IDTPIJURNF, @V_NRINSJURNF, @V_CDMODDOCFISC);
         END
         ELSE BEGIN
            INSERT INTO NOTAFISCAL
               (CDFILIAL,     NRLANCTONF,   CDEMPRESA,    CDINSCESTA,   CDINSCMUNI,
                CDFILIEMIT,   IDBLOQUEADO,  IDDOCFISCAL,  IDDOCFINANC,  NRNOTAFISC,
                DTEMISSAO,    DTENTRSAID,   VRPRODUTOS,   VRNOTAFISC,   IDENTRSAIDOP,
                CDTIPOOPER,   CDSERIE,      IDDOCCONTAB,  IDSTATUS,     IDDOCFATUR,
                IDDOCFISCENT, IDDOCFISCSAI, IDDOCESTOQUE, IDSISTEMA,    IDORIGDESTNF,
                DTEXPORTACAO, CDCLIENTE,    IDTPIJURNF,   NRINSJURNF,   CDMODDOCFISC)
            VALUES
               (@V_FILIPROC, @V_NRLANCTONF, @P_CDEMPRESA, @P_CDINSCESTA, @C_NOTAFISCAL_CDINSCMUNI,
                @C_NOTAFISCAL_CDFILIEMIT,  'S', 'S', 'N', @V_NRNOTAFISC,
                @C_NOTAFISCAL_DTEMISSAO, @C_NOTAFISCAL_DTEMISSAO, ISNULL(@C_NOTAFISCAL_VRNOTAFISC,0), ISNULL(@C_NOTAFISCAL_VRNOTAFISC,0), 'S',
                @P_CDOPERACAO, 'ECF', 'N', 'A', 'N',
                'N', 'N', 'N', 'FIS', 'C',
                @C_NOTAFISCAL_DTEMISSAO, @V_CDCLIENTE, @V_IDTPIJURNF, @V_NRINSJURNF, @V_CDMODDOCFISC);

         END;
      END;

      DECLARE C_IMPOSTONF CURSOR FOR(
          SELECT N.CDEMPRESA, N.CDINSCESTA, N.CDINSCMUNI, N.CDFILIEMIT, N.DTEMISSAO,
                 IT.CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, CDFISCALIT,
                 CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, SUM(VRCONTITIMP) AS VRCONTITIMP,
                 SUM(VRBASECALCIT) AS VRBASECALCIT, SUM(VRIMPOSTOIT) AS VRIMPOSTOIT, NRITPROIMPOS
          FROM NOTAFISCAL N, SERIENF S, ITEMPROIMPOS IT, IMPOSTO I
          WHERE (N.CDEMPRESA    = @P_CDEMPRESA)   AND
                (N.CDINSCESTA   = @P_CDINSCESTA)  AND
                (N.DTEMISSAO    = @C_NOTAFISCAL_DTEMISSAO) AND
                (N.IDENTRSAIDOP = 'S')           AND
                (N.IDSTATUS IN ('A', 'E'))       AND
                (ISNULL(N.IDSISTEMA, 'DFS') NOT IN ('REC', 'PAG', 'CMP', 'SUP')) AND
                (N.CDEMPRESA    = S.CDEMPRESA)   AND
                (N.CDINSCESTA   = S.CDINSCESTA)  AND
                (N.CDINSCMUNI   = S.CDINSCMUNI)  AND
                (N.CDSERIE      = S.CDSERIE)     AND
                (S.IDUTLEMCUPOM = 'S')           AND
                (IT.CDFILIAL    = N.CDFILIAL)    AND
                (IT.NRLANCTONF  = N.NRLANCTONF)  AND
                (IT.CDIMPOSTO = I.CDIMPOSTO)     AND
                (((CDFISCALIT  = '1') AND (IDIMPORECUP = 'S')) OR
                 ((IDIMPORECUP <> 'S') AND (VRALIQITEM <> 0 )))
          GROUP BY N.CDEMPRESA, N.CDINSCESTA, N.CDINSCMUNI, N.CDFILIEMIT, N.DTEMISSAO,
                   IT.CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, CDFISCALIT,
                   CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, NRITPROIMPOS
          UNION
          SELECT N.CDEMPRESA, N.CDINSCESTA, N.CDINSCMUNI, N.CDFILIEMIT, N.DTEMISSAO,
                 IT.CDIMPOSTO, 0 AS VRALIQITEM, 0 AS VRPERREDBCIT, 0 AS VRPARDEDIT, CDFISCALIT,
                 CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, SUM(VRCONTITIMP) AS VRCONTITIMP,
                 0 AS VRBASECALCIT, 0 AS VRIMPOSTOIT, NRITPROIMPOS
          FROM NOTAFISCAL N, SERIENF S, ITEMPROIMPOS IT, IMPOSTO I
          WHERE (N.CDEMPRESA    = @P_CDEMPRESA)   AND
                (N.CDINSCESTA   = @P_CDINSCESTA)  AND
                (N.DTEMISSAO    = @C_NOTAFISCAL_DTEMISSAO) AND
                (N.IDENTRSAIDOP = 'S')           AND
                (N.IDSTATUS IN ('A', 'E'))       AND
                (ISNULL(N.IDSISTEMA, 'DFS') NOT IN ('REC', 'PAG', 'CMP', 'SUP')) AND
                (N.CDEMPRESA    = S.CDEMPRESA)   AND
                (N.CDINSCESTA   = S.CDINSCESTA)  AND
                (N.CDINSCMUNI   = S.CDINSCMUNI)  AND
                (N.CDSERIE      = S.CDSERIE)     AND
                (S.IDUTLEMCUPOM = 'S')           AND
                (IT.CDFILIAL    = N.CDFILIAL)    AND
                (IT.NRLANCTONF  = N.NRLANCTONF)  AND
                (((IT.CDFISCALIT <> '1') AND (IDIMPORECUP = 'S')) OR
                 ((I.IDIMPORECUP  <> 'S') AND (VRALIQITEM = 0) ))
          GROUP BY N.CDEMPRESA, N.CDINSCESTA, N.CDINSCMUNI, N.CDFILIEMIT, N.DTEMISSAO,
                   IT.CDIMPOSTO, CDFISCALIT, CDSITUTRIBIT,
                   CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, NRITPROIMPOS)

      OPEN C_IMPOSTONF;
      FETCH NEXT FROM C_IMPOSTONF INTO @C_IMPOSTONF_CDEMPRESA, @C_IMPOSTONF_CDINSCESTA, @C_IMPOSTONF_CDINSCMUNI,
                                       @C_IMPOSTONF_CDFILIEMIT, @C_IMPOSTONF_DTEMISSAO,
                                       @C_IMPOSTONF_CDIMPOSTOIT, @C_IMPOSTONF_VRALIQIMPOIT, @C_IMPOSTONF_VRREDBCIMPOIT,
                                       @C_IMPOSTONF_VRPDEDIMPOIT, @C_IMPOSTONF_CDFISCIMPOIT, @C_IMPOSTONF_CDSTRIBIMPOIT,
                                       @C_IMPOSTONF_CDFOPERIMPOIT, @C_IMPOSTONF_CDSCFOPIMPOIT, @C_IMPOSTONF_NRSEQITPRO,
                                       @C_IMPOSTONF_VRCONTIMPOIT, @C_IMPOSTONF_VRBCALCIMPOIT, @C_IMPOSTONF_VRIMPOSIT,
                                       @C_IMPOSTONF_NRITPROIMPOS;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF NOT @V_LANCTEMP IS NULL BEGIN
            SELECT @V_CDIMPOSTO = MAX(CDIMPOSTO)
            FROM IMPOSTONF
            WHERE CDFILIAL     = @V_FILIPROC                 AND
                  NRLANCTONF   = @V_NRLANCTEMP               AND
                  CDIMPOSTO    = @C_IMPOSTONF_CDIMPOSTOIT    AND
                  VRALIQNF     = @C_IMPOSTONF_VRALIQIMPOIT   AND
                  CDFISCALNF   = @C_IMPOSTONF_CDFISCIMPOIT   AND
                  CDSITUTRIBNF = @C_IMPOSTONF_CDSTRIBIMPOIT  AND
                  CDFISCOPERNF = @C_IMPOSTONF_CDFOPERIMPOIT AND
                  IDIMPOSTONF  = @C_IMPOSTONF_NRITPROIMPOS;

            IF @V_CDIMPOSTO IS NULL BEGIN
               SELECT @V_SEQUIMPOSTNF = MAX(NRIMPOSNF)
               FROM IMPOSTONF
               WHERE CDFILIAL   = @V_FILIPROC AND
                     NRLANCTONF = @V_NRLANCTEMP;

               SET @V_SEQUIMPOSTNF = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC,@V_SEQUIMPOSTNF) + 1)),2);

               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                  VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF)
               VALUES(
                  @V_FILIPROC, @V_NRLANCTEMP, @C_IMPOSTONF_CDIMPOSTOIT, @V_SEQUIMPOSTNF, @C_IMPOSTONF_VRCONTIMPOIT,
                  @C_IMPOSTONF_VRREDBCIMPOIT, @C_IMPOSTONF_VRBCALCIMPOIT, @C_IMPOSTONF_VRALIQIMPOIT,
                  @C_IMPOSTONF_VRPDEDIMPOIT, @C_IMPOSTONF_VRIMPOSIT, @C_IMPOSTONF_CDFISCIMPOIT,
                  @C_IMPOSTONF_CDSTRIBIMPOIT, @C_IMPOSTONF_CDFOPERIMPOIT, @C_IMPOSTONF_CDSCFOPIMPOIT, @C_IMPOSTONF_NRITPROIMPOS);
            END
            ELSE BEGIN
               UPDATE IMPOSTONF
               SET VRCONTABILNF = VRCONTABILNF + @C_IMPOSTONF_VRCONTIMPOIT,
                   VRBASECALCNF = VRBASECALCNF + @C_IMPOSTONF_VRBCALCIMPOIT,
                   VRIMPOSTONF  = VRIMPOSTONF  + @C_IMPOSTONF_VRIMPOSIT
               WHERE CDFILIAL     = @V_FILIPROC                   AND
                     NRLANCTONF   = @V_NRLANCTEMP                 AND
                     CDIMPOSTO    = @C_IMPOSTONF_CDIMPOSTOIT      AND
                     VRALIQNF     = @C_IMPOSTONF_VRALIQIMPOIT     AND
                     CDFISCALNF   = @C_IMPOSTONF_CDFISCIMPOIT     AND
                     CDSITUTRIBNF = @C_IMPOSTONF_CDSTRIBIMPOIT  AND
                     CDFISCOPERNF = @C_IMPOSTONF_CDFOPERIMPOIT AND
                     IDIMPOSTONF  = @C_IMPOSTONF_NRITPROIMPOS;
            END;
         END
         ELSE BEGIN
            SELECT V_CDIMPOSTO = MAX(CDIMPOSTO)
            FROM IMPOSTONF
            WHERE CDFILIAL     = @V_FILIPROC                   AND
                  NRLANCTONF   = @V_NRLANCTONF                 AND
                  CDIMPOSTO    = @C_IMPOSTONF_CDIMPOSTOIT      AND
                  VRALIQNF     = @C_IMPOSTONF_VRALIQIMPOIT     AND
                  CDFISCALNF   = @C_IMPOSTONF_CDFISCIMPOIT     AND
                  CDSITUTRIBNF = @C_IMPOSTONF_CDSTRIBIMPOIT  AND
                  CDFISCOPERNF = @C_IMPOSTONF_CDFOPERIMPOIT AND
                  IDIMPOSTONF  = @C_IMPOSTONF_NRITPROIMPOS;

            IF @V_CDIMPOSTO IS NULL BEGIN
               INSERT INTO IMPOSTONF(
                  CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                  VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF)
               VALUES(
                  @V_FILIPROC, @V_NRLANCTONF, @C_IMPOSTONF_CDIMPOSTOIT, @V_SEQUIMPOSTNF, @C_IMPOSTONF_VRCONTIMPOIT,
                  @C_IMPOSTONF_VRREDBCIMPOIT, @C_IMPOSTONF_VRBCALCIMPOIT, @C_IMPOSTONF_VRALIQIMPOIT,
                  @C_IMPOSTONF_VRPDEDIMPOIT, @C_IMPOSTONF_VRIMPOSIT, @C_IMPOSTONF_CDFISCIMPOIT,
                  @C_IMPOSTONF_CDSTRIBIMPOIT, @C_IMPOSTONF_CDFOPERIMPOIT, @C_IMPOSTONF_CDSCFOPIMPOIT, @C_IMPOSTONF_NRITPROIMPOS);
            END
            ELSE BEGIN
               UPDATE IMPOSTONF
               SET VRCONTABILNF = VRCONTABILNF + @C_IMPOSTONF_VRCONTIMPOIT,
                   VRBASECALCNF = VRBASECALCNF + @C_IMPOSTONF_VRBCALCIMPOIT,
                   VRIMPOSTONF  = VRIMPOSTONF  + @C_IMPOSTONF_VRIMPOSIT
               WHERE CDFILIAL     = @V_FILIPROC               AND
                     NRLANCTONF   = @V_NRLANCTONF             AND
                     CDIMPOSTO    = @C_IMPOSTONF_CDIMPOSTOIT      AND
                     VRALIQNF     = @C_IMPOSTONF_VRALIQIMPOIT     AND
                     CDFISCALNF   = @C_IMPOSTONF_CDFISCIMPOIT     AND
                     CDSITUTRIBNF = @C_IMPOSTONF_CDSTRIBIMPOIT  AND
                     CDFISCOPERNF = @C_IMPOSTONF_CDFOPERIMPOIT AND
                     IDIMPOSTONF  = @C_IMPOSTONF_NRITPROIMPOS;
            END;
         END;
         SET @V_SEQUIMPOSTNF = RIGHT(REPLICATE('0',2)+RTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC,@V_SEQUIMPOSTNF) + 1)),2);

         FETCH NEXT FROM C_IMPOSTONF INTO @C_IMPOSTONF_CDEMPRESA, @C_IMPOSTONF_CDINSCESTA, @C_IMPOSTONF_CDINSCMUNI,
                                          @C_IMPOSTONF_CDFILIEMIT, @C_IMPOSTONF_DTEMISSAO,
                                          @C_IMPOSTONF_CDIMPOSTOIT, @C_IMPOSTONF_VRALIQIMPOIT, @C_IMPOSTONF_VRREDBCIMPOIT,
                                          @C_IMPOSTONF_VRPDEDIMPOIT, @C_IMPOSTONF_CDFISCIMPOIT, @C_IMPOSTONF_CDSTRIBIMPOIT,
                                          @C_IMPOSTONF_CDFOPERIMPOIT, @C_IMPOSTONF_CDSCFOPIMPOIT, @C_IMPOSTONF_NRSEQITPRO,
                                          @C_IMPOSTONF_VRCONTIMPOIT, @C_IMPOSTONF_VRBCALCIMPOIT, @C_IMPOSTONF_VRIMPOSIT,
                                          @C_IMPOSTONF_NRITPROIMPOS;
      END;

      CLOSE C_IMPOSTONF;
      DEALLOCATE C_IMPOSTONF;

      FETCH NEXT FROM C_NOTAFISCAL INTO @C_NOTAFISCAL_CDEMPRESA, @C_NOTAFISCAL_CDINSCESTA, @C_NOTAFISCAL_CDINSCMUNI, @C_NOTAFISCAL_CDFILIEMIT,
                                        @C_NOTAFISCAL_DTEMISSAO, @C_NOTAFISCAL_NRTAMNUMNFUT, @C_NOTAFISCAL_VRNOTAFISC;
   END;

   CLOSE C_NOTAFISCAL;
   DEALLOCATE C_NOTAFISCAL;


   DECLARE C_UPDATENOTA CURSOR FOR(SELECT CDFILIAL, NRLANCTONF
                                   FROM NOTAFISCAL
                                   WHERE CDEMPRESA  = @P_CDEMPRESA      AND
                                         CDINSCESTA = @P_CDINSCESTA     AND
                                         DTEMISSAO BETWEEN @P_DTINICIAL AND @P_DTFINAL AND
                                         IDENTRSAIDOP = 'S'             AND
                                         IDSISTEMA  = 'TMP'             AND
                                         CDSERIE    = 'ECF'             AND
                                         DTEXPORTACAO IS NOT NULL)
   OPEN C_UPDATENOTA;
   FETCH NEXT FROM C_UPDATENOTA INTO @C_UPDATENOTA_CDFILIAL, @C_UPDATENOTA_NRLANCTONF;
   WHILE (@@FETCH_STATUS = 0) BEGIN

      UPDATE NOTAFISCAL
      SET IDSISTEMA = 'FIS'
      WHERE CDFILIAL   = @C_UPDATENOTA_CDFILIAL AND
            NRLANCTONF = @C_UPDATENOTA_NRLANCTONF;

      FETCH NEXT FROM C_UPDATENOTA INTO @C_UPDATENOTA_CDFILIAL, @C_UPDATENOTA_NRLANCTONF;
   END;

   CLOSE C_UPDATENOTA;
   DEALLOCATE C_UPDATENOTA;

   DECLARE C_ATUALIZA CURSOR FOR (SELECT NF.CDFILIAL, NF.NRLANCTONF
                                  FROM NOTAFISCAL NF, SERIENF S
                                  WHERE NF.CDEMPRESA    = @P_CDEMPRESA    AND
                                        NF.CDINSCESTA   = @P_CDINSCESTA   AND
                                        NF.DTEMISSAO BETWEEN @P_DTINICIAL AND @P_DTFINAL AND
                                        NF.IDENTRSAIDOP = 'S'             AND
                                        NF.IDSTATUS IN ('A', 'E')         AND
                                        ISNULL(NF.IDSISTEMA, 'DFS') NOT IN ('REC', 'PAG', 'CMP', 'SUP') AND
                                        NF.CDEMPRESA   = S.CDEMPRESA      AND
                                        NF.CDINSCESTA  = S.CDINSCESTA     AND
                                        NF.CDINSCMUNI  = S.CDINSCMUNI     AND
                                        NF.CDSERIE     = S.CDSERIE        AND
                                        S.IDUTLEMCUPOM = 'S' )
   OPEN C_ATUALIZA;
   FETCH NEXT FROM C_ATUALIZA INTO @C_ATUALIZA_CDFILIAL, @C_ATUALIZA_NRLANCTONF;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      SELECT @V_NRCUPOM = MAX(SUBSTRING(DSDADOADIC,8,6))
      FROM DADOSADIC
      WHERE CDFILIAL = @C_ATUALIZA_CDFILIAL     AND
            NRLANCTONF = @C_ATUALIZA_NRLANCTONF AND
            SUBSTRING(DSDADOADIC,1,5) = 'Cupom';

      IF NOT (@V_NRCUPOM IS NULL) BEGIN
         UPDATE IMPOSTONF
         SET VRCONTABILNF = 0.00,
             VRBASECALCNF = 0.00,
             VRALIQNF     = 0.00,
             VRIMPOSTONF  = 0.00,
             VRPERREDBCNF = 0.00,
             CDFISCALNF   = '3',
             DSOBSFISCIT  = 'Ref.Cupom: '+@V_NRCUPOM
         WHERE CDFILIAL   = @C_ATUALIZA_CDFILIAL AND
               NRLANCTONF = @C_ATUALIZA_NRLANCTONF AND
               CDIMPOSTO  = '00';
      END;

      FETCH NEXT FROM C_ATUALIZA INTO @C_ATUALIZA_CDFILIAL, @C_ATUALIZA_NRLANCTONF;
   END;
   CLOSE C_ATUALIZA;
   DEALLOCATE C_ATUALIZA;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'GERANF_MAPARESUMO','5.50.xxx';
GO

